    001/*
    002 * Copyright (c) 2016 Chris K Wensel <chris@wensel.net>. All Rights Reserved.
    003 * Copyright (c) 2007-2017 Xplenty, Inc. All Rights Reserved.
    004 *
    005 * Project and contact information: http://www.cascading.org/
    006 *
    007 * This file is part of the Cascading project.
    008 *
    009 * Licensed under the Apache License, Version 2.0 (the "License");
    010 * you may not use this file except in compliance with the License.
    011 * You may obtain a copy of the License at
    012 *
    013 *     http://www.apache.org/licenses/LICENSE-2.0
    014 *
    015 * Unless required by applicable law or agreed to in writing, software
    016 * distributed under the License is distributed on an "AS IS" BASIS,
    017 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    018 * See the License for the specific language governing permissions and
    019 * limitations under the License.
    020 */
    021
    022package cascading.flow.local.stream.element;
    023
    024import cascading.flow.FlowElement;
    025import cascading.flow.FlowProcess;
    026import cascading.flow.stream.duct.Duct;
    027import cascading.flow.stream.element.MergeStage;
    028import cascading.tuple.TupleEntry;
    029
    030/** A version of Merge that synchronizes the receives for local mode */
    031public class SyncMergeStage extends MergeStage
    032  {
    033  public SyncMergeStage( FlowProcess flowProcess, FlowElement flowElement )
    034    {
    035    super( flowProcess, flowElement );
    036    }
    037
    038  /**
    039   * synchronized, as by default, each source gets its turn, no concurrent threads. Except in local mode
    040   *
    041   * @param previous
    042   * @param ordinal
    043   * @param tupleEntry
    044   */
    045  @Override
    046  public synchronized void receive( Duct previous, int ordinal, TupleEntry tupleEntry )
    047    {
    048    super.receive( previous, ordinal, tupleEntry );
    049    }
    050  }